/*

CommandSequence

K			LightWave 6.0
R|[lg	f[
wb_[		lwcmdseq.h

LWMODCOMMAND_CLASS
LWMODCOMMAND_VERSION

#include <lwcmdseq.h>
*/

#include "main.h"



EDError SM_getBone(void *scanData, const EDPolygonInfo *info);



/***********************************
	SetMuscle
	XPSEZMusclep
	^Oǉ
************************************/
XCALL_(int)SetMuscleActivate(long version, GlobalFunc *global, LWModCommand *local, void *serverData)
{
	if( LWMODCOMMAND_VERSION != version )
		return AFUNC_BADVERSION;

	SetMuscleData	data;
	MeshEditOp		*edit = local->editBegin(0,0,OPSEL_USER);

	if( !edit )
		return AFUNC_BADGLOBAL;

	edit->polyScan(edit->state, SM_getBone, &data, OPLYR_PRIMARY);
	data.global = global;
	data.edit = edit;
	if( !SetMusclePanel(&data, global) ){
		edit->done(edit->state, EDERR_NONE, 0);
		return AFUNC_OK;
	}
	//edit = local->editBegin(0,0,OPSEL_USER);
	for(unsigned int i=0; i<data.SelBones.size(); i++){
		LWPolID pol = data.SelBones[i].id;
		LWPolID	tip = data.SelBones[i].tipParent;
		const char *tipName;
		//	ʂPrbg̐ςێAQrbgڂAfterIK̃tO
		unsigned int flags = data.SelBones[i].holdVol | (data.SelBones[i].afterIK<<1);
		edit->polTag(edit->state, pol, LWPTAG_COLOR, "DkRed");
		if( tip ){
			tipName = edit->polyTag(edit->state, tip, LWPTAG_PART);
			edit->polTag(edit->state, pol, LWPTAG_MSLTIP, tipName);
		}
		char buf[16];
		sprintf(buf, "%d", flags);
		edit->polTag(edit->state, pol, LWPTAG_MSLFLAG, buf);
	}

	edit->done(edit->state, EDERR_NONE, 0);

	return AFUNC_OK;
}

//	IĂXPS擾
//	ׂẴXPSXgAbv@Ő[̐eIԎɎg
EDError SM_getBone(void *scanData, const EDPolygonInfo *info)
{
	SetMuscleData			*data = (SetMuscleData*)scanData;
	static SeMuscleParam	param = { NULL, 0, 1, NULL };

	if( LWPOLTYPE_BONE == info->type ){
		if( EDDF_SELECT & info->flags ){
			param.id = info->pol;
			data->SelBones.push_back(param);
		}
		data->AllBones.push_back(info->pol);
	}
	return EDERR_NONE;
}


