/*
*/

#ifndef	__LW_CVECTOR_H__
#define	__LW_CVECTOR_H__

#include <lwtypes.h>
#include <math.h>

//class LW_CVector {
//};

void Angle(const LWDVector vec, LWDVector out_angle)
{
	LWDVector	dpos = { vec[0], vec[1], vec[2] };

	if( 0.0 == vec[0] ){
			out_angle[0] = 0.0;
	}else if( 0.0 == vec[2] ){
		if( 0.0 > vec[0] ){
			out_angle[0] = -PI/2;
		}else{
			out_angle[0] = PI/2;
		}
	}else{
		out_angle[0] = atan2(vec[0], vec[2]);
	}

	dpos[2] = -dpos[0]*sin(-out_angle[0]) + dpos[2]*cos(-out_angle[0]);

	if( 0.0 == dpos[1] ){
			out_angle[1] = 0.0;
	}else if( 0.0 == dpos[2] ){
		if( 0.0 > dpos[1] ){
			out_angle[0] = PI/2;
		}else{
			out_angle[0] = -PI/2;
		}
	}else{
		out_angle[1] = -atan2(dpos[1], dpos[2]);
	}
};

void Angle(const LWDVector pos1, const LWDVector pos2, LWDVector out_angle)
{
	LWDVector	dpos;

	dpos[0] = pos2[0] - pos1[0];
	dpos[1] = pos2[1] - pos1[1];
	dpos[2] = pos2[2] - pos1[2];
	Angle(dpos, out_angle);
};

void Angle(const LWFVector pos1, const LWFVector pos2, LWDVector out_angle)
{
	LWDVector	dpos;

	dpos[0] = (double)(pos2[0] - pos1[0]);
	dpos[1] = (double)(pos2[1] - pos1[1]);
	dpos[2] = (double)(pos2[2] - pos1[2]);
	Angle(dpos, out_angle);
};

void Angle(const LWFVector vec, LWDVector out_angle)
{
	LWDVector	dpos;

	dpos[0] = (double)vec[0];
	dpos[1] = (double)vec[1];
	dpos[2] = (double)vec[2];
	Angle(dpos, out_angle);
};

double Angle(double x, double y)
{
	if( 0.0 == y ){
		if( 0.0 < x )
			return 0.0;
		else
			return PI;
	}
	if( 0.0 == x ){
		if( 0.0 < y )
			return PI/2;
		else
			return -PI/2;
	}
	return atan2(x, y);
};

double Angle(float x, float y)
{
	double	dx = (double)x;
	double	dy = (double)y;

	return Angle(dx, dy);
};

double Distance(LWDVector vec1, LWDVector vec2)
{
	return sqrt( (vec1[0]-vec2[0])*(vec1[0]-vec2[0]) + (vec1[1]-vec2[1])*(vec1[1]-vec2[1]) + (vec1[2]-vec2[2])*(vec1[2]-vec2[2]) );
}

double Distance(LWFVector vec1, LWFVector vec2)
{
	LWDVector	d1 = { (double)vec1[0], (double)vec1[1], (double)vec1[2] };
	LWDVector	d2 = { (double)vec2[0], (double)vec2[1], (double)vec2[2] };

	return Distance(d1, d2);
}

double Distance(LWDVector vec)
{
	return sqrt( vec[0]*vec[0] + vec[1]*vec[1] + vec[2]*vec[2] );
}

#endif	//__LW_CVECTOR_H__