/*

PanelServices

wb_[		lwpanel.h

*/

#include "main.h"
#include <lwpanel.h>

static LWPanControlDesc		desc;	 // required by macros in lwpanel.h
static LWValue				ival={LWT_INTEGER};
static LWValue				ivecval={LWT_VINT};		// required by macros in lwpanel.h
static LWValue				fval={LWT_FLOAT};
static LWValue				fvecval={LWT_VFLOAT};
static LWValue				sval={LWT_STRING};

static GlobalFunc	*g_global = NULL;



/**********************************
	SetMuscleppl
***********************************/

static SMP_width[] = { 120, 120, 60, 60 };

static int SMP_countFunc(void *eventData)
{
	SetMuscleData	*data = (SetMuscleData*)eventData;

	if( !data ) return 0;
	else return (int)data->SelBones.size();
}

static char * SMP_nameFunc(void *eventData, int n, int m)
{
	SetMuscleData	*data = (SetMuscleData*)eventData;

	if( !data ) return NULL;

	MeshEditOp	*edit = data->edit;

	if( -1 == n ){
		if( 0 == m ) return "O";
		else if(1 == m) return "Q";
		else if(2 == m) return "̐ςێ";
		else if(3 == m) return "AfterIK";
		else return NULL;
	}
	if( n < ((int)data->SelBones.size()) ){
		if(0 == m) return (char*)edit->polyTag(edit->state, data->SelBones[n].id, LWPTAG_PART);
		else if(1 == m) return data->SelBones[n].tipParent ? (char*)edit->polyTag(edit->state, data->SelBones[n].tipParent, LWPTAG_PART) : (char*)"--";
		else if(2 == m) return data->SelBones[n].holdVol ? (char*)"v" : (char*)" ";
		else if(3 == m) return data->SelBones[n].afterIK ? (char*)"v" : (char*)" ";
		else return NULL;
	}
	return NULL;
}

static int SMP_widthFunc(void *eventData, int n)
{
	return SMP_width[n];
}

LWPolID SMP_getTipParent(SetMuscleData *data, GlobalFunc *global)
{
	LWPanelFuncs	*panel = (LWPanelFuncs*)global(LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT);
	LWPanelID		pid = NULL;
	LWControl		*ctl_popup;
	const char		**items;
	int				index;
	LWPolID			result = NULL;

	items = new const char*[data->AllBones.size()+1];
	for(unsigned int i=0; i<data->AllBones.size(); i++){
		items[i] = data->edit->polyTag(data->edit->state, data->AllBones[i], LWPTAG_PART);
	}
	items[data->AllBones.size()] = NULL;

	if( pid = PAN_CREATE(panel, SN_SETMUSCLE) ){
		ctl_popup = POPUP_CTL(panel, pid, "TipParent", items);
		if( PAN_POST(panel, pid) ){
			GET_INT(ctl_popup, index);
			result = data->AllBones[index];
		}
		PAN_KILL(panel, pid);
	}
	delete[] items;
	
	return result;
}

static void SMP_listEvent(LWControl *ctl, void *eventData)
{
	SetMuscleData	*data = (SetMuscleData*)eventData;
	int				mouseX = CON_MOUSEX(ctl);
	int				index;

	if( !data ) return;
	GET_INT(ctl, index);
	if( 0 > index ) return;

	if( mouseX <= SMP_width[0] ) return;
	else if( mouseX < (SMP_width[0]+SMP_width[1]) ){
		data->SelBones[index].tipParent = SMP_getTipParent(data, data->global);
	}else if( mouseX < (SMP_width[0]+SMP_width[1]+SMP_width[2]) ){
		data->SelBones[index].holdVol ^= 1;
	}else{
		data->SelBones[index].afterIK ^= 1;
	}
	REDRAW_CON(ctl);
}

int SetMusclePanel(SetMuscleData *data, GlobalFunc *global)
{
	LWPanelFuncs	*panel = (LWPanelFuncs*)global(LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT);
	LWPanelID		pid = NULL;
	LWControl		*ctl_list;
	int				result = 0;

	if( !panel )
		return result;

	if( pid = PAN_CREATE(panel, SN_SETMUSCLE) ){
		ctl_list = MULTILIST_CTL(panel, pid, "", 360, 8, SMP_nameFunc, SMP_countFunc, SMP_widthFunc);

		ival.intv.value = (int)data;
		ctl_list->set(ctl_list, CTL_USERDATA, &ival);
		CON_SETEVENT(ctl_list, (int)SMP_listEvent, (int)data);
		if( PAN_POST(panel, pid) ){
			result = 1;
		}
		PAN_KILL(panel, pid);
	}

	return result;
}







/**********************************
	EZMuscleppl
***********************************/

XCALL_(LWError) Options(LWInstance inst)
{
	EZMuscleData	*data = (EZMuscleData*)inst;
	LWPanelFuncs	*panel = (LWPanelFuncs*)g_global(LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT);
	LWPanelID		pid = NULL;
	int				result = 0;
	LWControl		*ctl[3];
	int				temp;

	if( !panel )
		return "";

	if( pid = PAN_CREATE(panel, SN_EZMUSCLE) ){
		ctl[0] = ITEM_CTL(panel, pid, "Q", data->global, LWI_BONE);
		ctl[1] = BOOL_CTL(panel, pid, "̐ςێ");
		ctl[2] = BOOL_CTL(panel, pid, "After IK");

		temp = (int)data->param->items[1];
		SET_INT(ctl[0], temp);
		temp = data->param->holdVolume ? 1 : 0;
		SET_INT(ctl[1], temp);
		temp = data->param->afterIK ? 1 : 0;
		SET_INT(ctl[2], temp);

		if( PAN_POST(panel, pid) ){
			result = 1;
			GET_INT(ctl[0], temp);
			data->param->items[1] = (LWItemID)temp;
			GET_INT(ctl[1], temp);
			data->param->holdVolume = temp ? true : false;
			GET_INT(ctl[2], temp);
			data->param->afterIK = temp ? true : false;
			refreshSettings(data, NULL, NULL);
		}
		PAN_KILL(panel, pid);
	}

	return NULL;
}


XCALL_(int)EZMuscleInterface(long version, GlobalFunc *global, LWInterface *local, void *serverData)
{
	if( version != LWINTERFACE_VERSION )
		return AFUNC_BADVERSION;

	g_global = global;

	local->panel	= NULL;
	local->options	= Options;
	local->command	= NULL;

	return AFUNC_OK;
}

void refreshSettings(EZMuscleData *data, LWItemID id, EZMuscleGlobal *mg)
{
	LW_CMatrix_4x4	mat;

	//Ce[^̍Đݒ肪Kvȏꍇ
	if( id && mg ){
		data->param = mg->params.begin() + getMuscleGlobalIndex(mg, id);
	}

	data->param->restLength = data->binfo->restLength(data->param->items[0]);
	data->param->refPos[0] = data->param->refPos[1] = 0.0;
	data->param->refPos[2] = data->param->restLength;

	mat = LtoW(data->param->items[0], data->iinfo, 0.0);
	mat.Transform(data->param->refPos);
	mat = WtoL(data->param->items[1], data->iinfo, 0.0);
	mat.Transform(data->param->refPos);

	data->param->refresh = false;
}
